AbstractArchiveResource.JarInputStreamWrapper (Apache Tomcat 11.0.24 API Documentation)
Description: declaration: package: org.apache.catalina.webresources, class: AbstractArchiveResource, class: JarInputStreamWrapper

# Class AbstractArchiveResource.JarInputStreamWrapper

java.lang.Object
java.io.InputStream
org.apache.catalina.webresources.AbstractArchiveResource.JarInputStreamWrapper

All Implemented Interfaces:
  `Closeable, AutoCloseable`

Enclosing class:
  `AbstractArchiveResource`

protected class AbstractArchiveResource.JarInputStreamWrapper extends InputStream
This wrapper assumes that the InputStream was created from a JarFile obtained from a call to getArchiveResourceSet().openJarFile(). If this is not the case then the usage counting in AbstractArchiveResourceSet will break and the JarFile may be unexpectedly closed.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JarInputStreamWrapper(JarEntry jarEntry, InputStream is)`
  Creates a new JarInputStreamWrapper.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  `void`
  `close()`
  `Certificate[]`
  `getCertificates()`
  Returns the certificates.
  `void`
  `mark(int readlimit)`
  `boolean`
  `markSupported()`
  `int`
  `read()`
  `int`
  `read(byte[] b)`
  `int`
  `read(byte[] b, int off, int len)`
  `void`
  `reset()`
  `long`
  `skip(long n)`

  ### Methods inherited from class InputStream

  `nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JarInputStreamWrapper

    public JarInputStreamWrapper(JarEntry jarEntry, InputStream is)
    Creates a new JarInputStreamWrapper.
    Parameters:
      `jarEntry` - The JAR entry
      `is` - The input stream

- ## Method Details

  - ### read

    public int read() throws IOException
    Specified by:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### read

    public int read(byte[] b) throws IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### skip

    public long skip(long n) throws IOException
    Overrides:
      `skip` in class `InputStream`
    Throws:
      `IOException`

  - ### available

    public int available() throws IOException
    Overrides:
      `available` in class `InputStream`
    Throws:
      `IOException`

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `InputStream`
    Throws:
      `IOException`

  - ### mark

    public void mark(int readlimit)
    Overrides:
      `mark` in class `InputStream`

  - ### reset

    public void reset() throws IOException
    Overrides:
      `reset` in class `InputStream`
    Throws:
      `IOException`

  - ### markSupported

    public boolean markSupported()
    Overrides:
      `markSupported` in class `InputStream`

  - ### getCertificates

    public Certificate[] getCertificates()
    Returns the certificates.
    Returns:
      the certificates